/*
Autor: Marius M.

Mit diesem Programm können die 16 Geräte, die die ITZ-500 von Intertechno auf Kanal D schalten 
kann, geschaltet werden.
*/

//Eine Array mit den 16 Codes, mit der die Funksteckdosen angeschaltet werden
const int OnCodes [16] [12] = { 
  {
    0,0,1,1,1,1,1,1,1,0,0,0              }
  ,
  {
    0,0,1,1,0,1,1,1,1,0,0,0              }
  ,
  {
    0,0,1,1,1,0,1,1,1,0,0,0              }
  ,
  {
    0,0,1,1,0,0,1,1,1,0,0,0              }
  ,
  {
    0,0,1,1,1,1,0,1,1,0,0,0              }
  ,
  {
    0,0,1,1,0,1,0,1,1,0,0,0              }
  ,
  {
    0,0,1,1,1,0,0,1,1,0,0,0              }
  ,
  {
    0,0,1,1,0,0,0,1,1,0,0,0              }
  ,
  {
    0,0,1,1,1,1,1,0,1,0,0,0              }
  ,
  {
    0,0,1,1,0,1,1,0,1,0,0,0              }
  ,
  {
    0,0,1,1,1,0,1,0,1,0,0,0              }
  ,
  {
    0,0,1,1,0,0,1,0,1,0,0,0              }
  ,
  {
    0,0,1,1,1,1,0,0,1,0,0,0              }
  ,
  {
    0,0,1,1,0,1,0,0,1,0,0,0              }
  ,
  {
    0,0,1,1,1,0,0,0,1,0,0,0              }
  ,
  {
    0,0,1,1,0,0,0,0,1,0,0,0              }
};

//Eine Array mit den 16 Codes, mit der die Funksteckdosen ausgeschaltet werden
const int OffCodes [16] [12] = {
  {
    0,0,1,1,1,1,1,1,1,0,0,1              }
  ,
  {
    0,0,1,1,0,1,1,1,1,0,0,1              }
  ,
  {
    0,0,1,1,1,0,1,1,1,0,0,1              }
  ,
  {
    0,0,1,1,0,0,1,1,1,0,0,1              }
  ,
  {
    0,0,1,1,1,1,0,1,1,0,0,1              }
  ,
  {
    0,0,1,1,0,1,0,1,1,0,0,1              }
  ,
  {
    0,0,1,1,1,0,0,1,1,0,0,1              }
  ,
  {
    0,0,1,1,0,0,0,1,1,0,0,1              }
  ,
  {
    0,0,1,1,1,1,1,0,1,0,0,1              }
  ,
  {
    0,0,1,1,0,1,1,0,1,0,0,1              }
  ,
  {
    0,0,1,1,1,0,1,0,1,0,0,1              }
  ,
  {
    0,0,1,1,0,0,1,0,1,0,0,1              }
  ,
  {
    0,0,1,1,1,1,0,0,1,0,0,1              }
  ,
  {
    0,0,1,1,0,1,0,0,1,0,0,1              }
  ,
  {
    0,0,1,1,1,0,0,0,1,0,0,1              }
  ,
  {
    0,0,1,1,0,0,0,0,1,0,0,1              }
};

int aktBit;
int rfpin = 13;

void setup(){
  
}

void loop(){
 Schalten(2,1);
 delay(5000);

 Schalten(2,0);
 delay(5000); 
 
 //Gerät 2 wurde ein mal ein- und nach 5 Sekunden wieder ausgeschaltet.
}

void Schalten (int sltGerat, int sltZustand){
  //Methode um zu definieren, welches Gerät in welchen Zustand geschaltet werden soll.
  //Aufruf: Schalten(Gerätenummer (1 - 16), Zustand (1, 0);
  sltGerat = sltGerat - 1;

  if (sltZustand == 1){
    for (int j = 0; j < 7; j++){
      for (int i = 0; i < 12; i++){
        aktBit = OnCodes[sltGerat][i];
        sendBit(aktBit);
      }
      sendBit(2);
    }
  }
  if (sltZustand == 0){
    for (int j = 0; j < 7; j++){
      for (int i = 0; i < 12; i++){
        aktBit = OffCodes[sltGerat][i];
        sendBit(aktBit);
      }
      sendBit(2);
    }
  }

}


void sendBit(int z) { //Diese Funktion soll 0,1 oder 2 (sync) senden können.
  if (z == 0)
  { //Der Code für '0'
    digitalWrite(rfpin,HIGH);
    wait(1); //Warte ein mal 350 Mikrosekunden (kurzer Ausschalg)
    digitalWrite(rfpin,LOW);
    wait(3); //Warte drei mal 350 Mikrosekunden (lange Pause)
    digitalWrite(rfpin,HIGH);
    wait(3); //Warte drei mal 350 Mikrosekunden (langer Ausschalg)
    digitalWrite(rfpin,LOW);
    wait(1); //Warte ein mal 350 Mikrosekunden (kurze Pause)
  } 
  else
    if (z == 1)
    { //Der Code für '1'
      digitalWrite(rfpin,HIGH);
      wait(1); //Warte ein mal 350 Mikrosekunden (kurzer Ausschalg)
      digitalWrite(rfpin,LOW);
      wait(3); //Warte drei mal 350 Mikrosekunden (lange Pause)
      digitalWrite(rfpin,HIGH);
      wait(1); //Warte ein mal 350 Mikrosekunden (kurzer Ausschalg)
      digitalWrite(rfpin,LOW);
      wait(3); //Warte drei mal 350 Mikrosekunden (lange Pause)
    } 
    else
      if (z == 2)
      { //Der Code für das Synchronisationssignal
        digitalWrite(rfpin,HIGH);
        wait(1); //Warte ein mal 350 Mikrosekunden (kurzer Ausschalg)
        digitalWrite(rfpin,LOW);
        wait(31); //Warte 31 mal 350 Mikrosekunden (sehr lange Pause)
      }

}


void wait(int x) {
  //Methode um eine bestimmte Zeit nach jedem Signal zu warten.
  delayMicroseconds(x*350); //x*350 Mikrosekunden zwischen den Signalen warten
}
